% Author: Yanting Wu

% generate underlying GE channel states, a 2-state markov system
function generateStates 
global states lambda0 lambda1 T

states=zeros(T*1.2+1,1); % time slot -1 : 0
rr=rand(T*1.2,1);

for ii=1:T*1.2
    isJumped=1;
    if states(ii)==0
        if rr(ii) > lambda0
            isJumped=0;
        end
    else
        if rr(ii) < lambda1
            isJumped=0;
        end
    end
    states(ii+1)=(1-states(ii))*isJumped+states(ii)*(1-isJumped);
end


