% Author; Yanting Wu

% get the discounted reward for the arm with index armno
function getDiscountedReward(K)

global T R1 R2 C beta states ts X X2 NI TMAX armno; 

al=(1-beta)/(R2+C);
be=C/(R2+C);
count = 0;
mark = zeros(TMAX,1); % mark the states index with initial belief lambda0
R = zeros(TMAX,1); % reward got at each time slot in that period
mm = 1;

if K == armno -1 % K = infinity arm
   dr = R1*(1-beta^(TMAX/2))/(1-beta);

else % other arms
   for ii=1:TMAX 
       if count == K && states(ii+ts) ==0 % send aggressively, hits a failure, gets penalty -C, and goes back to sending conservative stage
           R(ii)=-C;
           count = 0;
       elseif count == K && states(ii+ts) == 1 % send aggressively, hits a success, gets reward R2, and keep sending aggressively
           R(ii)=R2;
       else
           if count== 0; % starts sending aggressively, with initial belief lambda0 
               mark(mm) = ii;
               mm = mm+1;
           end
           R(ii)=R1;
           count = count+1;

       end
   end
   for ii = TMAX+1: T
       if states(ii+ts)==0
           ts = ii+ts-1;
           break;
       end
   end

   % calculate discounted rewards
   dr = 0;
   for jj=1:mm-1
       if mark(jj) > TMAX/2 
           break;
       end
       for ii = mark(jj):mark(jj)+TMAX/2
           dr = dr + beta^(ii-mark(jj))*R(ii);
       end
   end
   if jj~=1
    dr = dr/(jj-1);
   end
end
X(K+1) = X(K+1) + dr*al+be; % updated the normalized discounted reward 
X2(K+1)= X2(K+1) + (al*dr+be)^2; % update the normalized discounted reward square
NI(K+1) = NI(K+1) + 1;
